<script setup lang="ts">
import { useRoute } from 'vue-router';
import { reactive, ref, onMounted, toRaw } from 'vue';
import { PageContainer } from '@ant-design-vue/pro-layout';
import { Form, message, Modal } from 'ant-design-vue/lib';
import { SizeType } from 'ant-design-vue/lib/config-provider';
import { MenuInfo } from 'ant-design-vue/lib/menu/src/interface';
import { ColumnsType } from 'ant-design-vue/lib/table';
import { parseDateToStr } from '@/utils/date-utils';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import useI18n from '@/hooks/useI18n';
import useUserStore from '@/store/modules/user';
import useNeInfoStore from '@/store/modules/neinfo';
import {
  addTraceTask,
  delTraceTask,
  getTraceTask,
  listPerfTask,
  updateTraceTask,
} from '@/api/perfManage/taskManage';
import useDictStore from '@/store/modules/dict';
import { regExpIPv4, regExpPort } from '@/utils/regular-utils';
const { getDict } = useDictStore();
const { t, currentLocale } = useI18n();
const route = useRoute();

/**路由标题 */
let title = ref<string>((route.meta.title as string) ?? '标题');

/**字典数据 */
let dict: {
  /**跟踪类型 */
  traceType: DictType[];
} = reactive({
  traceType: [],
});

/**表格所需option */
const taskManageOption = reactive({
  granulOption: [
    { label: '15M', value: '15M' },
    { label: '30M', value: '30M' },
    { label: '60M', value: '60M' },
    { label: '24H', value: '24H' },
  ],
  timeSlotAll: [{ label: '', value: '' }],
});

/**查询参数 */
let queryParams = reactive({
  /**网元类型 */
  neType: '',
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    neType: '',
    pageNum: 1,
    pageSize: 20,
  });
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
  /**勾选记录 */
  selectedRowKeys: (string | number)[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'middle',
  seached: true,
  data: [],
  selectedRowKeys: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: t('views.perfManage.taskManage.taskId'),
    dataIndex: 'id',
    align: 'center',
  },
  {
    title: t('views.perfManage.taskManage.neType'),
    dataIndex: 'neType',
    align: 'center',
  },
  {
    title: t('views.perfManage.taskManage.size'),
    dataIndex: 'granulOption',
    align: 'center',
  },
  {
    title: t('views.perfManage.taskManage.taskStatus'),
    dataIndex: 'status',
    key: 'status',
    align: 'center',
  },
  {
    title: t('views.perfManage.taskManage.addUser'),
    dataIndex: 'accountId',
    align: 'center',
  },
  {
    title: t('views.perfManage.taskManage.addTime'),
    dataIndex: 'createTime',
    align: 'center',
    customRender(opt) {
      if (!opt.value) return '';
      return parseDateToStr(opt.value);
    },
  },
  {
    title: t('common.operate'),
    key: 'id',
    align: 'center',
  },
];

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**
 * 备份信息删除
 * @param row 记录编号ID
 */
function fnRecordDelete(id: string) {
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.traceManage.task.delTaskTip', { num: id }),
    onOk() {
      const key = 'delTraceTask';
      message.loading({ content: t('common.loading'), key });
      delTraceTask(id).then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('views.traceManage.task.delTask', { num: id }),
            key,
            duration: 2,
          });
          fnGetList();
        } else {
          message.error({
            content: `${res.msg}`,
            key: key,
            duration: 2,
          });
        }
      });
    },
  });
}

/**查询信息列表 */
function fnGetList() {
  if (tableState.loading) return;
  tableState.loading = true;
  listPerfTask(toRaw(queryParams)).then(res => {
    if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.rows)) {
      // 取消勾选
      if (tableState.selectedRowKeys.length > 0) {
        tableState.selectedRowKeys = [];
      }
      tablePagination.total = res.total;
      tableState.data = res.rows;
    }
    tableState.loading = false;
  });
}

/**对话框对象信息状态类型 */
type ModalStateType = {
  /**详情框是否显示 */
  visibleByView: boolean;
  /**新增框或修改框是否显示 */
  visibleByEdit: boolean;
  /**标题 */
  title: string;
  /**网元类型设备对象 */
  neType: string[];
  /**网元类型设备对象接口 */
  neTypeInterface: Record<string, any>[];
  /**网元类型性能测量集 */
  neTypPerformance: Record<string, any>[];
  /**网元类型性能测量集选择 */
  neTypPerformanceList: [];
  /**网元类型设备对象接口选择 */
  neTypeInterfaceSelect: string[];
  /**任务开始结束时间 */
  timeRangePicker: [string, string];
  /**时间段多选 */
  timeSlotAll: [];
  /**表单数据 */
  from: Record<string, any>;
  /**确定按钮 loading */
  confirmLoading: boolean;
};

/**对话框对象信息状态 */
let modalState: ModalStateType = reactive({
  visibleByView: false,
  visibleByEdit: false,
  title: '',
  neType: [],
  neTypeInterface: [],
  neTypPerformance: [],
  neTypPerformanceList: [],
  neTypeInterfaceSelect: [],
  timeRangePicker: ['', ''],
  timeSlotAll: [],
  from: {
    id: '',
    neType: '',
    neId: '',
    granulOption: '',
    traceType: 'Device',
    startTime: '',
    endTime: '',
    comment: '',
    // 跟踪类型用户
    imsi: '',
    msisdn: '',
    // 跟踪类型接口
    srcIp: '',
    dstIp: '',

    kpiSet: '',
    periods: [],
    signalPort: '',
  },
  confirmLoading: false,
});

/**对话框内表单属性和校验规则 */
const modalStateFrom = Form.useForm(
  modalState.from,
  reactive({
    traceType: [
      {
        required: true,
        message: t('views.traceManage.task.trackTypePlease'),
      },
    ],
    neId: [
      {
        required: true,
        message: t('views.traceManage.task.neTypePlease'),
      },
    ],
    endTime: [
      {
        required: true,
        message: t('views.traceManage.task.rangePickerPlease'),
      },
    ],
    // 跟踪用户
    imsi: [
      {
        required: true,
        message: t('views.traceManage.task.imsiPlease'),
      },
    ],
    msisdn: [
      {
        required: true,
        message: t('views.traceManage.task.msisdnPlease'),
      },
    ],
    // 跟踪接口
    srcIp: [
      {
        required: true,
        pattern: regExpIPv4,
        message: t('views.traceManage.task.srcIpPlease'),
      },
    ],
    dstIp: [
      {
        required: true,
        pattern: regExpIPv4,
        message: t('views.traceManage.task.dstIpPlease'),
      },
    ],
    interfaces: [
      {
        required: true,
        message: t('views.traceManage.task.interfacesPlease'),
      },
    ],
    signalPort: [
      {
        required: true,
        pattern: regExpPort,
        message: t('views.traceManage.task.signalPortPlease'),
      },
    ],
  })
);

/**网元类型选择对应修改 */
function fnNeChange(_: any, item: any) {
  modalState.from.neType = item[1].neType;
  modalState.from.neId = item[1].neId;

  modalState.from.interfaces = '';
  modalState.neTypeInterfaceSelect = [];
  modalState.neTypPerformanceList = [];

  // 网元信令接口
  fnSelectInterfaceInit(item[1].neType);
}

function fnPeriodsSelect(item: any, timeString: any) {
  console.log(item);
  console.log(timeString);

  taskManageOption.timeSlotAll.push({
    label: timeString.join(','),
    value: item.join(','),
  });
  modalState.from.timeSlotAll.push(timeString.join(','));
}

/**开始结束时间选择对应修改 */
function fnRangePickerChange(_: any, item: any) {
  console.log(item);
  modalState.from.startTime = item[0];
  modalState.from.endTime = item[1];
}

/**时间段选择后回调 */
function fnChange(open: any) {
  console.log(open);
  if (!open) {
    modalState.from.periods.push(modalState.from.timeSlotAll);
  }
}

/**性能测量数据集对应修改 */
function fnSelectInterface(s: any, option: any) {
  modalState.from.kpiSet = s.join(',');
  const groupedData = option.reduce((groups: any, item: any) => {
    const { kpiCode, ...rest } = item;
    if (!groups[kpiCode]) {
      groups[kpiCode] = [];
    }
    groups[kpiCode].push(rest);
    return groups;
  }, {});
  let kpiGroup = []; //最终上报给网元的kpi_set数据
  let kpisArr = []; //整理kpis数据所用
  //进行打包网元所需的规范数据
  for (var key in groupedData) {
    for (let i = 0; i < groupedData[key].length; i++) {
      //  console.log(i, groupedKpi[key][i].name)
      kpisArr.push(groupedData[key][i].value);
    }
    kpiGroup.push({ Code: key, KPIs: kpisArr });
    kpisArr = [];
  }
  modalState.from.kpiSet = JSON.stringify(kpiGroup);
}

/**性能测量数据集选择初始 */
function fnSelectInterfaceInit(neType: string) {
  //console.logg(currentLocale.value); //当前语言
  const performance = useNeInfoStore().perMeasurementList.filter(
    i => i.neType === neType
  );
  //进行分组选择
  const groupedData = performance.reduce((groups: any, item: any) => {
    const { kpiCode, ...rest } = item;
    if (!groups[kpiCode]) {
      groups[kpiCode] = [];
    }
    groups[kpiCode].push(rest);
    return groups;
  }, {});
  modalState.neTypPerformance = Object.keys(groupedData).map(kpiCode => {
    return {
      label: kpiCode,
      options: groupedData[kpiCode].map((item: any) => {
        return {
          value: item.kpiId,
          label:
            currentLocale.value === 'zh_CN'
              ? JSON.parse(item.titleJson).cn
              : JSON.parse(item.titleJson).en,
          kpiCode: kpiCode,
        };
      }),
    };
  });
}

/**
 * 对话框弹出显示为 新增或者修改
 * @param noticeId 网元id, 不传为新增
 */
function fnModalVisibleByVive(id: string) {
  if (modalState.confirmLoading) return;
  const hide = message.loading(t('common.loading'), 0);
  modalState.confirmLoading = true;
  getTraceTask(id).then(res => {
    modalState.confirmLoading = false;
    hide();
    if (res.code === RESULT_CODE_SUCCESS) {
      modalState.neType = [res.data.neType, res.data.neId];
      modalState.timeRangePicker = [res.data.startTime, res.data.endTime];
      modalState.from = Object.assign(modalState.from, res.data);
      // 接口
      if (res.data.traceType === 'Interface') {
        if (
          res.data.interfaces.length > 4 &&
          res.data.interfaces.includes('[')
        ) {
          modalState.neTypeInterfaceSelect = JSON.parse(res.data.interfaces);
        }
        fnSelectInterfaceInit(res.data.neType);
      }
      modalState.title = t('views.traceManage.task.viewTask');
      modalState.visibleByView = true;
    } else {
      message.error(t('views.traceManage.task.errorTaskInfo'), 3);
    }
  });
}

/**
 * 对话框弹出显示为 新增或者修改
 * @param noticeId 网元id, 不传为新增
 */
function fnModalVisibleByEdit(id?: string) {
  if (!id) {
    modalStateFrom.resetFields();
    modalState.title = t('views.traceManage.task.addTask');
    modalState.visibleByEdit = true;
  } else {
    if (modalState.confirmLoading) return;
    const hide = message.loading(t('common.loading'), 0);
    modalState.confirmLoading = true;
    getTraceTask(id).then(res => {
      modalState.confirmLoading = false;
      hide();
      if (res.code === RESULT_CODE_SUCCESS && res.data) {
        modalState.neType = [res.data.neType, res.data.neId];
        modalState.timeRangePicker = [res.data.startTime, res.data.endTime];
        modalState.from = Object.assign(modalState.from, res.data);
        // 接口
        if (res.data.traceType === 'Interface') {
          if (
            res.data.interfaces.length > 4 &&
            res.data.interfaces.includes('[')
          ) {
            modalState.neTypeInterfaceSelect = JSON.parse(res.data.interfaces);
          }
          fnSelectInterfaceInit(res.data.neType);
        }
        modalState.title = t('views.traceManage.task.editTask');
        modalState.visibleByEdit = true;
      } else {
        message.error(t('views.traceManage.task.errorTaskInfo'), 3);
      }
    });
  }
}

/**
 * 对话框弹出确认执行函数
 * 进行表达规则校验
 */
function fnModalOk() {
  const from = toRaw(modalState.from);
  let valids = ['traceType', 'neId', 'endTime'];
  if (from.traceType === 'UE') {
    valids = valids.concat(['imsi', 'msisdn']);
  }
  if (from.traceType === 'Interface') {
    valids = valids.concat(['srcIp', 'dstIp', 'interfaces', 'signalPort']);
  }
  from.accountId = useUserStore().userName;
  modalStateFrom
    .validate(valids)
    .then(e => {
      modalState.confirmLoading = true;
      const traceTask = from.id ? updateTraceTask(from) : addTraceTask(from);
      const hide = message.loading(t('common.loading'), 0);
      traceTask
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', { msg: modalState.title }),
              duration: 3,
            });
            modalState.visibleByEdit = false;
            modalStateFrom.resetFields();
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          modalState.confirmLoading = false;
          fnGetList();
        });
    })
    .catch(e => {
      message.error(t('common.errorFields', { num: e.errorFields.length }), 3);
    });
}

/**
 * 对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnModalCancel() {
  modalState.visibleByView = false;
  modalState.visibleByEdit = false;
  modalState.confirmLoading = false;
  modalStateFrom.resetFields();
  modalState.timeRangePicker = ['', ''];
  modalState.neTypeInterfaceSelect = [];
  modalState.neTypPerformanceList = [];

  modalState.neType = [];
  modalState.neTypeInterface = [];
}

onMounted(() => {
  // 初始字典数据
  Promise.allSettled([getDict('trace_type')]).then(resArr => {
    if (resArr[0].status === 'fulfilled') {
      dict.traceType = resArr[0].value;
    }
  });
  Promise.allSettled([
    // 获取网元网元列表
    useNeInfoStore().fnNelist(),
    // 获取性能测量集列表
    useNeInfoStore().fnNeTaskPerformance(),
  ]).finally(() => {
    // 获取列表数据
    fnGetList();
  });
});
</script>

<template>
  <PageContainer :title="title">
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.traceManage.task.neType')"
              name="neType "
            >
              <a-auto-complete
                v-model:value="queryParams.neType"
                :options="useNeInfoStore().getNeSelectOtions"
                allow-clear
                :placeholder="t('views.traceManage.task.neTypePlease')"
              />
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <a-button type="primary" @click.prevent="fnModalVisibleByEdit()">
          <template #icon><PlusOutlined /></template>
          {{ t('common.addText') }}
        </a-button>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown trigger="click" placement="bottomRight">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">{{
                    t('common.size.default')
                  }}</a-menu-item>
                  <a-menu-item key="middle">{{
                    t('common.size.middle')
                  }}</a-menu-item>
                  <a-menu-item key="small">{{
                    t('common.size.small')
                  }}</a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="id"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ x: true }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'traceType'">
            <DictTag :options="dict.traceType" :value="record.traceType" />
          </template>
          <template v-if="column.key === 'id'">
            <a-space :size="8" align="center">
              <a-tooltip>
                <template #title>{{ t('common.viewText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnModalVisibleByVive(record.id)"
                >
                  <template #icon><ProfileOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip>
                <template #title>{{ t('common.editText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnModalVisibleByEdit(record.id)"
                >
                  <template #icon><FormOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip>
                <template #title>{{ t('common.deleteText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnRecordDelete(record.id)"
                >
                  <template #icon><DeleteOutlined /></template>
                </a-button>
              </a-tooltip>
            </a-space>
          </template>
        </template>
      </a-table>
    </a-card>

    <!-- 详情框 -->
    <a-modal
      width="800px"
      :visible="modalState.visibleByView"
      :title="modalState.title"
      @cancel="fnModalCancel"
    >
      <a-form layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.traceManage.task.trackType')"
              name="traceType"
            >
              <DictTag
                :options="dict.traceType"
                :value="modalState.from.traceType"
              />
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.traceManage.task.neType')"
              name="neType"
            >
              <a-cascader
                :value="modalState.neType"
                :options="useNeInfoStore().getNeCascaderOtions"
                disabled
              />
            </a-form-item>
          </a-col>
        </a-row>

        <!-- 用户跟踪 -->
        <template v-if="modalState.from.traceType === 'UE'">
          <a-form-item
            :label="t('views.traceManage.task.msisdn')"
            name="msisdn"
          >
            {{ modalState.from.msisdn }}
          </a-form-item>
          <a-form-item :label="t('views.traceManage.task.imsi')" name="imsi">
            {{ modalState.from.imsi }}
          </a-form-item>
        </template>

        <!-- 接口跟踪 -->
        <template v-if="modalState.from.traceType === 'Interface'">
          <a-row :gutter="16">
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item
                :label="t('views.traceManage.task.srcIp')"
                name="srcIp"
              >
                {{ modalState.from.srcIp }}
              </a-form-item>
            </a-col>
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item
                :label="t('views.traceManage.task.dstIp')"
                name="dstIp"
              >
                {{ modalState.from.dstIp }}
              </a-form-item>
            </a-col>
          </a-row>
          <a-form-item
            :label="t('views.traceManage.task.interfaces')"
            name="endTime"
          >
            {{ modalState.neTypeInterfaceSelect }}
          </a-form-item>
          <a-form-item
            :label="t('views.traceManage.task.signalPort')"
            name="endTime"
          >
            {{ modalState.from.signalPort }}
          </a-form-item>
        </template>

        <a-form-item
          :label="t('views.traceManage.task.rangePicker')"
          name="endTime"
        >
          <a-range-picker
            disabled
            :value="modalState.timeRangePicker"
            allow-clear
            bordered
            :show-time="{ format: 'HH:mm:ss' }"
            format="YYYY-MM-DD HH:mm:ss"
            value-format="YYYY-MM-DD HH:mm:ss"
            style="width: 100%"
          ></a-range-picker>
        </a-form-item>
        <a-form-item
          :label="t('views.traceManage.task.comment')"
          name="comment"
        >
          {{ modalState.from.comment }}
        </a-form-item>
      </a-form>
      <template #footer>
        <a-button key="cancel" @click="fnModalCancel">{{
          t('common.close')
        }}</a-button>
      </template>
    </a-modal>

    <!-- 新增框或修改框 -->
    <a-modal
      width="800px"
      :keyboard="false"
      :mask-closable="false"
      :visible="modalState.visibleByEdit"
      :title="modalState.title"
      :confirm-loading="modalState.confirmLoading"
      @ok="fnModalOk"
      @cancel="fnModalCancel"
    >
      <a-form name="modalStateFrom" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.traceManage.task.neType')"
              name="neType"
              v-bind="modalStateFrom.validateInfos.neId"
            >
              <a-cascader
                v-model:value="modalState.neType"
                :options="useNeInfoStore().getNeCascaderOtions"
                @change="fnNeChange"
                :allow-clear="false"
                :placeholder="t('views.traceManage.task.neTypePlease')"
              />
            </a-form-item>
          </a-col>
        </a-row>

        <a-form-item
          :label="t('views.traceManage.task.interfaces')"
          name="interfaces"
          v-bind="modalStateFrom.validateInfos.interfaces"
          v-show="modalState.neType.length !== 0"
        >
          <a-select
            mode="multiple"
            placeholder="Please select"
            v-model:value="modalState.neTypPerformanceList"
            :options="modalState.neTypPerformance"
            @change="fnSelectInterface"
          >
          </a-select>
        </a-form-item>

        <a-form-item
          :label="t('views.traceManage.task.rangePicker')"
          name="endTime"
          v-bind="modalStateFrom.validateInfos.endTime"
        >
          <a-range-picker
            v-model:value="modalState.timeRangePicker"
            @change="fnRangePickerChange"
            allow-clear
            bordered
            :show-time="{ format: 'HH:mm:ss' }"
            format="YYYY-MM-DD HH:mm:ss"
            value-format="YYYY-MM-DD HH:mm:ss"
            :placeholder="[
              t('views.traceManage.task.startTime'),
              t('views.traceManage.task.endTime'),
            ]"
            style="width: 100%"
          ></a-range-picker>
        </a-form-item>

        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.perfManage.taskManage.granulOption')"
              name="granulOption"
              v-bind="modalStateFrom.validateInfos.granulOption"
            >
              <a-select
                v-model:value="modalState.from.granulOption"
                :options="taskManageOption.granulOption"
              >
              </a-select>
            </a-form-item>
          </a-col>
        </a-row>

        <a-form-item
          :label="t('views.traceManage.task.interfaces')"
          name="interfaces"
          v-bind="modalStateFrom.validateInfos.interfaces"
          v-if="
            modalState.from.granulOption &&
            modalState.from.granulOption !== '24H'
          "
        >
          <a-select
            mode="multiple"
            placeholder="Please select"
            v-model:value="modalState.from.periods"
            :options="taskManageOption.timeSlotAll"
            :open="false"
          >
          </a-select>
          <a-time-range-picker
            format="HH:mm"
            value-format="HH:MM:00"
            @change="fnPeriodsSelect"
            @open-change="fnChange"
          />
        </a-form-item>
        <a-form-item
          :label="t('views.traceManage.task.comment')"
          name="comment"
        >
          <a-textarea
            v-model:value="modalState.from.comment"
            :auto-size="{ minRows: 2, maxRows: 6 }"
            :maxlength="250"
            :show-count="true"
            :placeholder="t('views.traceManage.task.commentPlease')"
          />
        </a-form-item>
      </a-form>
    </a-modal>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
